var config              = require('../config/settings.json')
  , request         	= require('request')
  , system              = require('./dle-system')
  , fs      			= require('fs');

var passport = require('passport')
  , OAuth2Strategy = require('passport-oauth2');
  //, OAuth2Strategy = require('passport-oauth2').OAuth2Strategy;


//namespacing to protect module variables
//access like this alert(auth_passport.namespaceR);
//other apps can call it the sameway but need to 
//be later in the js load order
var auth_passport = (function () {

	var testVariableNotUsed = "auth_passport";
	
	return {
		namespaceR: testVariableNotUsed
	};
	
} )(); //end of namespace

 var errors = [];
 var userProfileJson;
 
 //collect and return errors here
 module.exports.errors = errors;
 //module.exports.userProfileJson = userProfileJson;

//test
module.exports.passport = passport;

//testing fix for UNABLE_TO_VERIFY_LEAF_SIGNATURE error
//this could be the token path that is failing config.iamConnInfo.tokenUrl -- check again when working
//not trusted than ignore cert
if (!config.iamConnInfo.trustedCert) {
	process.env['NODE_TLS_REJECT_UNAUTHORIZED'] = 0;
}

authenticationInfo = {
    oauth2LoginOptions: {
        authorizationURL: config.iamConnInfo.authorizationUrl,  
    	tokenURL: config.iamConnInfo.tokenUrl, 
    	clientID: config.iamConnInfo.clientID, 
    	//grant_type: config.iamConnInfo.grantType,
    	clientSecret: config.iamConnInfo.clientSecret,
    	callbackURL: config.iamConnInfo.callbackUrl 
    },
	iamSessionProfile: {
        method          : 'POST',
        uri             : config.iamConnInfo.iamSessionProfileService,
        timeout         : 20000,  //set timeout for 20 seconds - need it to fail before proxy fails
        key             : fs.readFileSync(config.nodeStartUp.localHttpsKey),
    	cert			: fs.readFileSync(config.nodeStartUp.localHttpsCert),
    }
};

system.logger.warn('auth-passport: Module Loaded.');

passport.serializeUser(function(user, done) {
	system.logger.info("auth-public: Serializing " + user.username);
    done(null, user); //user is the token
});
     
passport.deserializeUser(function(obj, done) {
    system.logger.info("auth-public: Deserializing " + obj.username);
    //system.logger.debug("auth-public: Deserializing "+obj);
    done(null, obj);
});
        
//var options = authenticationInfo.oauth2LoginOptions;
/**options['callbackURL'] = appPublicUrl + config.paths.apiUri + '/login/auth/ha/callback';**/      
       
passport.use('provider', new OAuth2Strategy(authenticationInfo.oauth2LoginOptions,       
//passport.use(new OAuth2Strategy(authenticationInfo.oauth2LoginOptions,
  function(accessToken, refreshToken, profile, done) {

	errors = [];
    system.logger.info('auth-passport: '+accessToken);
    system.logger.info('auth-passport arguments: '+arguments);
    
    module.exports.userAccessToken = accessToken;
    
 	var options = authenticationInfo.iamSessionProfile;
 	options['multipart'] = [{ 
			'content-type': 'application/json',
       body: JSON.stringify({
			"access_token": accessToken,
    		"grant_type": "auth_code",
    		"appliesTo": config.iamConnInfo.serviceAppliesTo,
    		"token_type": "bearer"})
 	}];
   
    request(options, function(error, response, body) {

        if (!error && response.statusCode === 200) {
            try {
            	system.logger.info('200: body: '+body);
                userProfileJson = JSON.parse(body);
                
                if ( checkBodyForFailureMessage(userProfileJson) ) {
                	system.logger.trace('checkBodyForFailureMessage Failure'); 
                 	module.exports.errors = errors;
                 	return done(null, null);
                };

                system.logger.info('200: name: '+userProfileJson.username);
                system.logger.info('200: loa: '+userProfileJson.loa);
                module.exports.userProfileJson = userProfileJson; //exported above fails to include content?
            } catch(e) {
                var detail = (e) ? e : 'Invalid response from IAM';
                system.logger.error('Invalid response from IAM: ' + detail);
            	errors.push(['3', 'Invalid response from IAM']);
            	module.exports.errors = errors;
                return done(null, null);
            }
            system.logger.trace('auth-public: Sucessfully authorized ');
            //return done(null, userProfileJson);  //passport.initialize() middleware not in use
            return done(null, accessToken);  //passport.initialize() middleware not in use
        } else {
        	//service unreachable failure happens here
            if (error) { 
            	system.logger.error('Failure on Obtaining Access Level Error: ' + error);
            	errors.push(['4', 'Failure on Obtaining Access Level ' + error]); 
            	system.logger.debug('error.stack: '+error.stack);
            }  
            if  (response && response.statusCode != 200) {
            	system.logger.error('Failure on Obtaining Access Level with Status Code: ' + response.statusCode);
            	errors.push(['5', 'Failure on Obtaining Access Level ' + response.statusCode]);
            }
            module.exports.errors = errors;
            //return done('Error with login', null); // returning a value here causes node to choke-n-die
            return done(null, null);
         }
         
    });

  }
));  //end passport.use

function checkBodyForFailureMessage(userProfileJson) {
 
 system.logger.trace('checkBodyForFailure');
 
 if (userProfileJson.authorized=='FALSE') {
  system.logger.error('Body Failure user not authorized: ' + userProfileJson.authorized);
  errors.push(['3', 'User Not Authorized']); 
  return(true);
 }; 
 
 if (userProfileJson.faultstring) {
  system.logger.error('Body Failure faultstring: ' + userProfileJson.faultstring);
  errors.push(['3', userProfileJson.faultstring]); 
  return(true);
 }; 
 
 return(false);
};
