//"use strict";

//Global variables
//var currentPage,
var dleRouter = new app.Router(); 
//Backbone.history.start(); //retain historical clicks

//namespacing to protect module variables
//access like this alert(dle_app.namespaceR);
//other apps can call it the sameway but need to 
//be later in the js load order
var dle_app = (function () {

	var testVariableNotUsed = "dle-app";
	var userDecline = "Declined";
	var eulaDeclineMessage = "You have declined the End User License Agreement. Please dismiss this message and you will be returned to the launchpad.";
	
	return {
		namespaceR: testVariableNotUsed,
		userDecline: userDecline,
		eulaDeclineMessage: eulaDeclineMessage
	};
	
} )(); //end of namespace

$(document).ready(function() {
	Backbone.history.start(); //retain historical clicks	

	//intercept data-confirm click event
	//only need to load one time
	$('a[data-confirm-navbar]').click(function(ev) {
		var inBody = $(this).attr('data-confirm-navbar');
		var inHref = $(this).attr('data-href');
		var inTitle = $(this).attr('data-title');
		var confirmationDialog = modalConfirmDialog(inTitle, inBody);
		
		confirmationDialog.then(function (confirmationResponse) {							
			if (confirmationResponse) {
				window.location=inHref;
			}
		});
	});
});


function declineEulaExit() {
	var inTitle = dle_app.userDecline;
	var inBody = dle_app.eulaDeclineMessage;
	$('#myModal').css('background-color', 'black', 'opacity', '1 !important');
	$("#cancelButton").hide();
	var confirmationDialog = modalConfirmDialog(inTitle, inBody);
	
	confirmationDialog.then(function (confirmationResponse) {							
		if (confirmationResponse) {
			window.location=launchPadLink;
		}
	});
};

//reset event with new screen content
function resetDataConfirmEvent() {
	$('a[data-confirm]').off('click',addDataConfirm);
	$('a[data-confirm]').on('click',addDataConfirm);
}

function addDataConfirm() {
	var inBody = $(this).attr('data-confirm');
	var inHref = $(this).attr('data-href');
	var inTitle = $(this).attr('data-title');
	var confirmationDialog = modalConfirmDialog(inTitle, inBody);
	
	confirmationDialog.then(function (confirmationResponse) {							
		if (confirmationResponse) {
			window.location=inHref;
		}
	});	
}

function modalConfirmDialog(title, bodyText) {
  var deferredQueue = jQuery.Deferred();
  var modalConfirm = $('#myModal');
  
  $('#myModalTitle').html(title);  
  $('#myModalText').html(bodyText); 
  modalConfirm.modal('show');
  
  $('#okButton').off('click').click(function () {
    modalConfirm.modal('hide');
    deferredQueue.resolve(true);
  });
  
  $('#cancelButton').off('click').click(function () {
    modalConfirm.modal('hide');
    deferredQueue.resolve(false);
  });
  
  return deferredQueue.promise();
};

function ConfirmEulaYesNo() {
  var deferredQueue = jQuery.Deferred();
  var modalConfirm = $('#eula-modal');
  modalConfirm.modal('show');

  $('#acceptEulaBtn').off('click').click(function () {
    modalConfirm.modal('hide');
    deferredQueue.resolve(true);
  });
  
  $('#declineEulaBtn').off('click').click(function () {
    modalConfirm.modal('hide');
    deferredQueue.resolve(false);
  });
  
  return deferredQueue.promise();
};


$('#myModal').on('shown.bs.modal', function () {
  $('#okButton').focus();
});

$('#eula-modal').on('shown.bs.modal', function () {
  $('#acceptEulaBtn').focus();
});

function identifyMenu(activeButton) {
	
	//alert('identifyMenu: '+activeButton);
	var menuId = "#" + activeButton;
	var navigationArray=['#home', '#exit', '#about', '#help', '#info', '#resolution', '#auth', '#contactus'];  

	for (i in navigationArray) {  
        $(navigationArray[i]).removeClass('active'); 
        $(navigationArray[i]+'Selected').html("");
    }
	
	$(menuId).addClass('active');
	$(menuId+'Selected').html("selected");	
} //function identifyButton

function addInfoScreen508events() {

	$('#howDsLogonAppHelpMe').on('show.bs.collapse', function () {
	  $("#toggleHowDsLogonAppHelpMe").html("hide content"); 
	  $("#headingHowDsLogonAppHelpMe a").attr("aria-expanded","true");	  
	  //alert("howDsLogonAppHelpMe hide");
	});
	
	$('#howDsLogonAppHelpMe').on('hidden.bs.collapse', function () {
	  $("#toggleHowDsLogonAppHelpMe").html("show content");
	  $("#headingHowDsLogonAppHelpMe a").attr("aria-expanded","false");
	  //alert("howDsLogonAppHelpMe show");
	});
	
	$('#howDoIRegisterForDsLogon').on('show.bs.collapse', function () {
	  $("#toggleHowDoIRegisterForDsLogon").html("hide content");
	  $("#headingHowDoIRegisterForDsLogon a").attr("aria-expanded","true");
	  //alert("howDoIRegisterForDsLogon hide");
	});
	
	$('#howDoIRegisterForDsLogon').on('hidden.bs.collapse', function () {
	  $("#toggleHowDoIRegisterForDsLogon").html("show content");
	  $("#headingHowDoIRegisterForDsLogon a").attr("aria-expanded","false");
	  //alert("howDoIRegisterForDsLogon show");
	});
	
	$('#whatIsADsLogon').on('show.bs.collapse', function () {
	  $("#toggleWhatIsADsLogon").html("hide content"); 
	  $("#headingWhatIsADsLogon a").attr("aria-expanded","true");
	  //alert("whatIsADsLogon hide");
	});
	
	$('#whatIsADsLogon').on('hidden.bs.collapse', function () {
	  $("#toggleWhatIsADsLogon").html("show content");
	  $("#headingWhatIsADsLogon a").attr("aria-expanded","false");
	  //alert("whatIsADsLogon show");
	});
	
	$('#whoIsEligibleForDsLogon').on('show.bs.collapse', function () {
	  $("#toggleWhoIsEligibleForDsLogon").html("hide content"); 
	  $("#headingWhoIsEligibleForDsLogon a").attr("aria-expanded","true");
	  //alert("whoIsEligibleForDsLogon hide");
	});
	
	$('#whoIsEligibleForDsLogon').on('hidden.bs.collapse', function () {
	  $("#toggleWhoIsEligibleForDsLogon").html("show content");
	  $("#headingWhoIsEligibleForDsLogon a").attr("aria-expanded","false");
	  //alert("whoIsEligibleForDsLogon show");
	});
	
	$('#howDoIUpgradeFromLevel1ToLevel2Info').on('show.bs.collapse', function () {
	  $("#toggleHowDoIUpgradeFromLevel1ToLevel2Info").html("hide content"); 
	  $("#headingHowDoIUpgradeFromLevel1ToLevel2Info a").attr("aria-expanded","true");	  
	  //alert("howDoIUpgradeFromLevel1ToLevel2Info hide");
	});
	
	$('#howDoIUpgradeFromLevel1ToLevel2Info').on('hidden.bs.collapse', function () {
	  $("#toggleHowDoIUpgradeFromLevel1ToLevel2Info").html("show content");
	  $("#headingHowDoIUpgradeFromLevel1ToLevel2Info a").attr("aria-expanded","false");
	  //alert("howDoIUpgradeFromLevel1ToLevel2Info show");
	});	
	
	$('#whatIsDeers').on('show.bs.collapse', function () {
	  $("#toggleWhatIsDeers").html("hide content"); 
	  $("#headingWhatIsDeers a").attr("aria-expanded","true");
	  //alert("whatIsDeers hide");
	});
	
	$('#whatIsDeers').on('hidden.bs.collapse', function () {
	  $("#toggleWhatIsDeers").html("show content");
	  $("#headingWhatIsDeers a").attr("aria-expanded","false");
	  //alert("whatIsDeers show");
	});
	
	$('#whatIsDifferenceBetween1and2').on('show.bs.collapse', function () {
	  $("#toggleWhatIsDifferenceBetween1and2").html("hide content"); 
	  $("#headingWhatIsDifferenceBetween1and2 a").attr("aria-expanded","true");
	  //alert("whatIsDifferenceBetween1and2 hide");
	});
	
	$('#whatIsDifferenceBetween1and2').on('hidden.bs.collapse', function () {
	  $("#toggleWhatIsDifferenceBetween1and2").html("show content");
	  $("#headingWhatIsDifferenceBetween1and2 a").attr("aria-expanded","false");
	  //alert("whatIsDifferenceBetween1and2 show");
	});
	
	$('#dsLogonMobileApps').on('show.bs.collapse', function () {
	  $("#toggleDsLogonMobileApps").html("hide content"); 
	  $("#headingDsLogonMobileApps a").attr("aria-expanded","true");
	  //alert("dsLogonMobileApps hide");
	});
	
	$('#dsLogonMobileApps').on('hidden.bs.collapse', function () {
	  $("#toggleDsLogonMobileApps").html("show content");
	  $("#headingDsLogonMobileApps a").attr("aria-expanded","false");
	  //alert("dsLogonMobileApps show");
	});

};

function addResolutionScreen508events() {

	$('#useHealtheVetInsteadDsLogon').on('show.bs.collapse', function () {
	  $("#toggleUseHealtheVetInsteadDsLogon").html("hide content"); 
	  $("#headingUseHealtheVetInsteadDsLogon a").attr("aria-expanded","true");
	  //alert("useHealtheVetInsteadDsLogon hide");
	});
	
	$('#useHealtheVetInsteadDsLogon').on('hidden.bs.collapse', function () {
	  $("#toggleUseHealtheVetInsteadDsLogon").html("show content");
	  $("#headingUseHealtheVetInsteadDsLogon a").attr("aria-expanded","false");
	  //alert("useHealtheVetInsteadDsLogon show");
	});
	
	$('#howDoIRecoverUsernamePassword').on('show.bs.collapse', function () {
	  $("#toggleHowDoIRecoverUsernamePassword").html("hide content");
	  $("#headingHowDoIRecoverUsernamePassword a").attr("aria-expanded","true");
	  //alert("howDoIRecoverUsernamePassword hide"); 
	});
	
	$('#howDoIRecoverUsernamePassword').on('hidden.bs.collapse', function () {
	  $("#toggleHowDoIRecoverUsernamePassword").html("show content");
	  $("#headingHowDoIRecoverUsernamePassword a").attr("aria-expanded","false");
	  //alert("howDoIRecoverUsernamePassword show");
	});
	
	$('#howDoIUpgradeFromLevel1ToLevel2').on('show.bs.collapse', function () {
	  $("#toggleHowDoIUpgradeFromLevel1ToLevel2").html("hide content"); 
	  $("#headingHowDoIUpgradeFromLevel1ToLevel2 a").attr("aria-expanded","true");
	  //alert("howDoIUpgradeFromLevel1ToLevel2 hide"); 
	});
	
	$('#howDoIUpgradeFromLevel1ToLevel2').on('hidden.bs.collapse', function () {
	  $("#toggleHowDoIUpgradeFromLevel1ToLevel2").html("show content");
	  $("#headingHowDoIUpgradeFromLevel1ToLevel2 a").attr("aria-expanded","false");
	  //alert("howDoIUpgradeFromLevel1ToLevel2 show"); 
	});
	
	$('#remoteProofingFailsTryAgain').on('show.bs.collapse', function () {
	  $("#toggleRemoteProofingFailsTryAgain").html("hide content"); 
	  $("#headingRemoteProofingFailsTryAgain a").attr("aria-expanded","true");
	  //alert("remoteProofingFailsTryAgain hide");
	});
	
	$('#remoteProofingFailsTryAgain').on('hidden.bs.collapse', function () {
	  $("#toggleRemoteProofingFailsTryAgain").html("show content");
	  $("#headingRemoteProofingFailsTryAgain a").attr("aria-expanded","false");
	  //alert("remoteProofingFailsTryAgain show");
	});
	
	$('#whatIsRemoteProofing').on('show.bs.collapse', function () {
	  $("#toggleWhatIsRemoteProofing").html("hide content"); 
	  $("#headingWhatIsRemoteProofing a").attr("aria-expanded","true");
	  //alert("whatIsRemoteProofing hide");
	});
	
	$('#whatIsRemoteProofing').on('hidden.bs.collapse', function () {
	  $("#toggleWhatIsRemoteProofing").html("show content");
	  $("#headingWhatIsRemoteProofing a").attr("aria-expanded","false");
	  //alert("whatIsRemoteProofing show");
	});

};

function addHelpScreen508events() {

	$('#howToInfoModule').on('show.bs.collapse', function () {
	  $("#toggleHowToInfoModule").html("hide content"); 
	  $("#headingHowToInfoModule a").attr("aria-expanded","true");
	  //alert("howToInfoModule hide");
	});
	
	$('#howToInfoModule').on('hidden.bs.collapse', function () {
	  $("#toggleHowToInfoModule").html("show content");
	  $("#headingHowToInfoModule a").attr("aria-expanded","false");
	  //alert("howToInfoModule show");
	});
	
	$('#howToExecModule').on('show.bs.collapse', function () {
	  $("#toggleHowToExecModule").html("hide content");
	  $("#headingHowToExecModule a").attr("aria-expanded","true");	  
	  //alert("howToExecModule hide"); 
	});
	
	$('#howToExecModule').on('hidden.bs.collapse', function () {
	  $("#toggleHowToExecModule").html("show content");
	  $("#headingHowToExecModule a").attr("aria-expanded","false");
	  //alert("howToExecModule show");
	});
	
	$('#howToResolutionModule').on('show.bs.collapse', function () {
	  $("#toggleHowToResolutionModule").html("hide content"); 
	  $("#headingHowToResolutionModule a").attr("aria-expanded","true");
	  //alert("howToResolutionModule hide"); 
	});
	
	$('#howToResolutionModule').on('hidden.bs.collapse', function () {
	  $("#toggleHowToResolutionModule").html("show content");
	  $("#headingHowToResolutionModule a").attr("aria-expanded","false");
	  //alert("howToResolutionModule show"); 
	});
	
	$('#whoToContactForSupport').on('show.bs.collapse', function () {
	  $("#toggleWhoToContactForSupport").html("hide content"); 
	  $("#headingWhoToContactForSupport a").attr("aria-expanded","true");
	  //alert("whoToContactForSupport hide");
	});
	
	$('#whoToContactForSupport').on('hidden.bs.collapse', function () {
	  $("#toggleWhoToContactForSupport").html("show content");
	  $("#headingWhoToContactForSupport a").attr("aria-expanded","false");
	  //alert("whoToContactForSupport show");
	});
	
	$('#howToNavigateLaunchpad').on('show.bs.collapse', function () {
	  $("#toggleHowToNavigateLaunchpad").html("hide content"); 
	  $("#headingHowToNavigateLaunchpad a").attr("aria-expanded","true");
	  //alert("howToNavigateLaunchpad hide");
	});
	
	$('#howToNavigateLaunchpad').on('hidden.bs.collapse', function () {
	  $("#toggleHowToNavigateLaunchpad").html("show content");
	  $("#headingHowToNavigateLaunchpad a").attr("aria-expanded","false");
	  //alert("howToNavigateLaunchpad show");
	});
	
	$('#whereTrainingMaterials').on('show.bs.collapse', function () {
	  $("#toggleWhereTrainingMaterials").html("hide content"); 
	  $("#headingWhereTrainingMaterials a").attr("aria-expanded","true");
	  //alert("whereTrainingMaterials hide");
	});
	
	$('#whereTrainingMaterials').on('hidden.bs.collapse', function () {
	  $("#toggleWhereTrainingMaterials").html("show content");
	  $("#headingWhereTrainingMaterials a").attr("aria-expanded","false");
	  //alert("whereTrainingMaterials show");
	});
	
	$('#whereSubmitFeedback').on('show.bs.collapse', function () {
	  $("#toggleWhereSubmitFeedback").html("hide content"); 
	  $("#headingWhereSubmitFeedback a").attr("aria-expanded","true");
	  //alert("whereSubmitFeedback hide");
	});
	
	$('#whereSubmitFeedback').on('hidden.bs.collapse', function () {
	  $("#toggleWhereSubmitFeedback").html("show content");
	  $("#headingWhereSubmitFeedback a").attr("aria-expanded","false");
	  //alert("whereSubmitFeedback show");
	});
	
	$('#whatBrowsersUse').on('show.bs.collapse', function () {
	  $("#toggleWhatBrowsersUse").html("hide content"); 
	  $("#headingWhatBrowsersUse a").attr("aria-expanded","true");
	  //alert("whatBrowsersUse hide");
	});
	
	$('#whatBrowsersUse').on('hidden.bs.collapse', function () {
	  $("#toggleWhatBrowsersUse").html("show content");
	  $("#headingWhatBrowsersUse a").attr("aria-expanded","false");
	  //alert("whatBrowsersUse show");
	});

};

function addAuthHelp508events() {

	$('#stepsDsLogon').on('show.bs.collapse', function () {
	  $("#toggleStepsDsLogon").html("hide content"); 
	  $("#headingStepsDsLogon a").attr("aria-expanded","true");
	  //alert("stepsDsLogon hide");
	});
	
	$('#stepsDsLogon').on('hidden.bs.collapse', function () {
	  $("#toggleStepsDsLogon").html("show content");
	  $("#headingStepsDsLogon a").attr("aria-expanded","false");
	  //alert("stepsDsLogon show");
	});
	
	$('#logonPasswordIssue').on('show.bs.collapse', function () {
	  $("#toggleLogonPasswordIssue").html("hide content");
	  $("#headingLogonPasswordIssue a").attr("aria-expanded","true");
	  //alert("logonPasswordIssue hide"); 
	});
	
	$('#logonPasswordIssue').on('hidden.bs.collapse', function () {
	  $("#toggleLogonPasswordIssue").html("show content");
	  $("#headingLogonPasswordIssue a").attr("aria-expanded","false");
	  //alert("logonPasswordIssue show");
	});
	
	$('#technicalIssue').on('show.bs.collapse', function () {
	  $("#toggleTechnicalIssue").html("hide content"); 
	  $("#headingTechnicalIssue a").attr("aria-expanded","true");
	  //alert("technicalIssue hide"); 
	});
	
	$('#technicalIssue').on('hidden.bs.collapse', function () {
	  $("#toggleTechnicalIssue").html("show content");
	  $("#headingTechnicalIssue a").attr("aria-expanded","false");
	  //alert("technicalIssue show"); 
	});

};

//auto closes navbar following a selection on mobile devices
$(document).on('click','.navbar-collapse.in',function(e) {
    if( $(e.target).is('a') ) {
        $(this).collapse('hide');
    }
});

//sets mobile menu text to reflect menu status for screen readers
$('#collapse').on('show.bs.collapse', function () {
  $("#toggleNavigation").html("Menu, close menu"); 
  //alert("Menu, close menu");
});

$('#collapse').on('hidden.bs.collapse', function () {
  $("#toggleNavigation").html("Menu, open menu");
  //alert("Menu, open menu");
});

/** Removed per 508 review
$('#contactus').on('show.bs.dropdown', function () {
  $("#contactUsDropdown").html("hide content");
  //alert("dropdown show");
});

$('#contactus').on('hidden.bs.dropdown', function () {
  $("#contactUsDropdown").html("show content");
  //alert("dropdown hide");
});
**/

$('#auth').on('show.bs.dropdown', function () {
  $("#authDropdown").html("hide content");
  //alert("dropdown show");
});

$('#auth').on('hidden.bs.dropdown', function () {
  $("#authDropdown").html("show content");
  //alert("dropdown hide");
});

/**	
function getParameterByName(name) {
	name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
	var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
		results = regex.exec(location.search);
	return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}
**/
