// Namespace our router
var app = app || {};

//namespacing to protect module variables
//access like this alert(router.namespaceR);
//other apps can call it the sameway but need to 
//be later in the js load order
var router = (function () {

	var testVariableNotUsed = "auth_passport";
	var dmdcMinHeight = 671;
	var dmdcMinWidth = 767;
	
	return {
		namespaceR: testVariableNotUsed,
		dmdcMinHeight: dmdcMinHeight,
		dmdcMinWidth: dmdcMinWidth
	};
	
} )(); //end of namespace

app.Router = Backbone.Router.extend({

routes :{
	"": "noCopy",	
	
	"about" : "aboutContent",
	"auth" : "authContent",
	"authenticated" : "successContent",
	"serverFailure" : "erroredContent",
	
	"help" : "helpContent",
	"home" : "homeContent",
	
	"info" : "infoContent", 
	"howDoIRegisterForDsLogon" : "howDoIRegisterForDsLogonContent",
	"howDsLogonAppHelpMe" : "howDsLogonAppHelpMeContent",
	"whatIsADsLogon" : "whatIsADsLogonContent",
	"whoIsEligibleForDsLogon" : "whoIsEligibleForDsLogonContent",

	"resolution" : "resolutionContent",
	"howDoIUpgradeFromLevel1ToLevel2" : "howDoIUpgradeFromLevel1ToLevel2Content",
	"howDoIRecoverUsernamePassword" : "howDoIRecoverUsernamePasswordContent",
	"whatIsRemoteProofing" : "whatIsRemoteProofingContent"	
},

noCopy: function() {
  setScreen("home", "Main Screen", false);

  if (typeof accessLevel == 'undefined') {
  	accessLevel = null;
  }
  
  if (accessLevel) {
	window.location.href= "#authenticated";
  }	else if (errors) {
  	window.location.href= "#serverFailure";
  } else {
  	var mainView = new app.mainView();
  	$("#content").html(mainView.render().el);
  	window.scrollTo(0,0); //sets focus to top of page for 508
  }
},

homeContent: function() {
  setScreen("home", "Main Screen", true);
  var mainView = new app.mainView();
  $("#content").html(mainView.render().el);
  window.scrollTo(0,0); //sets focus to top of page for 508
},

aboutContent: function() {
  setScreen("about", "About Screen", true);
  var aboutView = new app.aboutView();
  $("#content").html(aboutView.render().el);
  window.scrollTo(0,0); //sets focus to top of page for 508
},

helpContent: function() {
  setScreen("help", "Help Screen", true);
  var helpView = new app.helpView();
  $("#content").html(helpView.render().el);
  addHelpScreen508events();
  window.scrollTo(0,0); //sets focus to top of page for 508
},

infoContent: function() {
  info();
},

howDoIRegisterForDsLogonContent: function() {
  info();
  $("#howDoIRegisterForDsLogon").addClass('in');
  $("#howDoIRegisterForDsLogon").trigger("show.bs.collapse");
},

howDsLogonAppHelpMeContent: function() {
  info();
  $("#howDsLogonAppHelpMe").addClass('in');
  $("#howDsLogonAppHelpMe").trigger("show.bs.collapse");
},

whatIsADsLogonContent: function() {
  info();
  $("#whatIsADsLogon").addClass('in');
  $("#whatIsADsLogon").trigger("show.bs.collapse");
},

whoIsEligibleForDsLogonContent: function() {
  info();
  $("#whoIsEligibleForDsLogon").addClass('in');
  $("#whoIsEligibleForDsLogon").trigger("show.bs.collapse");
},

authContent: function() {
  setScreen("auth", "Execution Test Access Screen", true);
  var authView = new app.authView();

  $("#content").hide();
  $("#content").html(authView.render().el);

  //alert ("height: "+$(window).height() + " - width: "+ $(window).width());
  //alert ("min height: "+router.dmdcMinHeight + " - min width: "+ router.dmdcMinWidth);

  //if (($(window).height()>router.dmdcMinHeight) && ($(window).width()>router.dmdcMinWidth))
  if ($(window).width()>router.dmdcMinWidth)
  {
	$('.screenSize').hide();
  } else {
	$('a.auth-site').attr('disabled', true); 
	$('.screenSize').focus(); //focus doesn't seem to work on h5
  }

   $("#content").show();
   addAuthHelp508events();
   resetDataConfirmEvent();
   window.scrollTo(0, 0); //sets focus to top of page for 508
},

successContent: function() {
  setScreen("auth", "Execution Test Access Success Screen", false);
  var loaView = new app.loaView();
  $("#content").html(loaView.render().el);
  window.scrollTo(0,0); //sets focus to top of page for 508
},

resolutionContent: function() {
	resolution();
},

howDoIRecoverUsernamePasswordContent: function() {
  resolution();
  $("#howDoIRecoverUsernamePassword").addClass('in');
  $("#howDoIRecoverUsernamePassword").trigger("show.bs.collapse");
},

howDoIUpgradeFromLevel1ToLevel2Content: function() {
  resolution();
  $("#howDoIUpgradeFromLevel1ToLevel2").addClass('in');
  $("#howDoIUpgradeFromLevel1ToLevel2").trigger("show.bs.collapse");
},

whatIsRemoteProofingContent: function() {
  resolution();
  $("#whatIsRemoteProofing").addClass('in');
  $("#whatIsRemoteProofing").trigger("show.bs.collapse");
},

erroredContent: function() {
  setScreen("auth", "Execution Test Access Error Screen", false);
  $("#srErrorsElement").html("Error content displays failures encountered within the Application");
  
  var errorsView = new app.errorsView();
  $("#content").html(errorsView.render().el);
  window.scrollTo(0,0); //sets focus to top of page for 508
}

});

function info() {
  setScreen("info", "Information Screen", true);
  var infoView = new app.infoView();
  $("#content").html(infoView.render().el);
  addInfoScreen508events();
  resetDataConfirmEvent();
  window.scrollTo(0,0); //sets focus to top of page for 508
}

function resolution() {
  setScreen("resolution", "Resolution Screen", true);
  var resolutionView = new app.resolutionView();
  $("#content").html(resolutionView.render().el);
  addResolutionScreen508events();
  resetDataConfirmEvent();
  window.scrollTo(0,0); //sets focus to top of page for 508
}

function setScreen(menu, title, clearMessage) {
  identifyMenu(menu);
  document.title = title;
  if (clearMessage) {
  	$("#messages").html("");
  }  
  
  try {
    if (!localStorage.DLEA_Eula_Accepted) {
	  var confirmationDialog = ConfirmEulaYesNo();
	  confirmationDialog.then( function (confirmationResponse) {							
		if (confirmationResponse) {
			localStorage.DLEA_Eula_Accepted = new Date().toUTCString();
		} else {
			declineEulaExit();
		}
	  });
    }	  
  } catch(e) {
	alert("Please enable Web Storage to properly run the Applicaiton.  Thank You");
	declineEulaExit();
  }
}
